<template>
  <div class="guest_page">
    <div class="bg-wrapper">
      <Background></Background>
    </div>
    <div class="guest_page_container">
      <div clas="logo_container">
        <router-link :to="{name: 'Login'}" class="logo_link">
          <img :src="`${$baseUrl}/images/logo-HETA2.png`" alt="HETACHAIN" class="img">
        </router-link>
        <div class="guest_page_form">
          <div class="form-container">
            <div class="guest_page_form_header">
              <div class="title">{{ $t('auth.reset_password.title') }}</div>
            </div>

            <div class="guest_page_form_body">
              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-password"></i>
                </div>
                <input
                  @keyup.enter="resetPassword"
                  v-validate="'required|min:6|max:128|regex:^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d).+$|no_space|confirmed:password_confirmation'"
                  data-vv-validate-on="none"
                  @focus="resetError"
                  :placeholder="$t('auth.placeholder.password')"
                  v-model="user.password"
                  v-tooltip="$t('auth.register.password_tooltip')"
                  name="password"
                  type="password"
                  class="form_input">
                <span class="invalid-feedback" v-if="isShowPasswordError">{{ errors.first('password') }} </span>
              </div>
              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-password"></i>
                </div>
                <input
                  data-vv-as="password confirmation"
                  @keyup.enter="resetPassword"
                  data-vv-validate-on="none"
                  ref="password_confirmation"
                  v-validate="'required'"
                  @focus="resetError"
                  :placeholder="$t('auth.placeholder.repeat_password')"
                  v-model="user.password_confirmation"
                  name="password_confirmation"
                  type="password"
                  class="form_input">
                <span class="invalid-feedback"
                      v-if="isShowPasswordConfirmedError">{{ errors.first('password') }}</span>
                <span class="invalid-feedback"
                      v-if="errors.has('password_confirmation')">{{ errors.first('password_confirmation') }}</span>
              </div>

              <div class="form_actions">
                <button type="button" class="button-primary" @click="resetPassword">{{ $t('auth.btn.submit') }}</button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <guest-page-footer></guest-page-footer>
    <modal v-if="displayModal" @close="modalOff">
      <component v-bind:is="currentModal" :modal-data="modalData"></component>
    </modal>
  </div>
</template>
<script>
import { mapState } from 'vuex';
import rf from '../../../common/requests/RequestFactory';
import ModalMixin from '../../../common/components/ModalMixin';
import CheckAuthMixin from './CheckAuthMixin';
import OtpConfirmModal from '../../../common/components/Otp/OtpConfirmModal.vue';
import GuestPageFooter from '../../components/GuestPageFooter.vue';
import Background from '../../components/Dashboard/Background';
import ResetPasswordErrorModal from './Modal/ResetPasswordErrorModal.vue';

export default {
  components: {
    GuestPageFooter,
    Background
  },
  data () {
    return {
      user: {
        email: '',
        token: this.$route.params.token,
        password: '',
        password_confirmation: '',
      }
    };
  },
  computed: {
    ...mapState([
      'supportedLocales',
    ]),
    isShowPasswordError () {
      return this.errors.has('password') && !this.errors.firstByRule('password', 'confirmed');
    },
    isShowPasswordConfirmedError () {
      return !!this.errors.firstByRule('password', 'confirmed') && !this.errors.firstByRule('password_confirmation', 'required');
    }
  },
  mixins: [CheckAuthMixin, ModalMixin],
  methods: {
    resetError () {
      this.errors.clear();
    },
    resetPassword () {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          const params = Object.assign({}, this.user);
          rf.getRequest('UserRequest').submitResetPassword(params)
            .then(res => {
              this.resetPasswordSuccess();
            })
            .catch((error) => {
              const errors = error.errors;
              this.errors.clear();
              Object.keys(errors).forEach((key) => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
              if (this.errors.has('user')) {
                this.$broadcast('open-modal', ResetPasswordErrorModal, {message: this.errors.first('user')});
                return;
              }
              if (this.errors.has('token')) {
                this.$broadcast('open-modal', ResetPasswordErrorModal, {message: this.errors.first('token')});
                return;
              }
              if (this.errors.has('code')) {
                this.errors.clear();
                this.$broadcast('open-modal', OtpConfirmModal, {
                  callback: this.requestResetPassword,
                  key: `${this._uid}-requestResetPassword`,
                  params: params,
                });
              }
            });
        });
    },
    resetPasswordSuccess () {
      this.$router.push('/login');
      this.$toasted.show(this.$t('auth.reset_password.success_message'), {
        theme: 'bubble',
        position: 'top-right',
        duration: 2000
      });
    },
    requestResetPassword (params) {
      return rf.getRequest('UserRequest').submitResetPassword(params);
    },
  },
  created () {
    const url = new window.URL(window.location.href);
    this.user.email = url.searchParams.get('email');
    this.$on(`${this._uid}-requestResetPassword-confirm-otp-successful`, () => {
      this.resetPasswordSuccess();
    });
  }
};
</script>
<style lang="scss" scoped>
  .guest_page_form {
    margin-top: -24px !important;
    padding-left: 36px !important;
  }
  .guest_page_form_header .sub_title {
    margin-top: 10px!important;
  }
  .guest_page_form_body {
    margin-top: 17px;
  }
  .form_input {
    width: 100% !important;
    /*padding-left: 28px !important;*/
  }
  .text-white {
    color: white;
  }
  .checked_group {
    font-family: Roboto;
    font-size: 14px;
    color: #989898;

    padding-left: 5px;
    position: relative;
    margin-bottom: 20px;
    .form_check_input {
      font-size: 10px;
      position: absolute;
      top: 5px;
      left: 15px;
    }
    .form-check-label {
      padding-left: 28px;
    }
  }
  .login_box {
    text-align: center;
    margin-top: 19px;
  }
  .text-orange {
    font-size: 12px;
    margin-left: 8px;
    position: relative;
    left: -4px;
  }
  .logo_link {
    display: inline-block;
  }

  @media screen and (max-width: 1023px) {
    .logo_link {
      margin-bottom: 40px;
    }
    .guest_page_container {
      text-align: center;
    }
    .guest_page {
      .guest_page_form {
        display: block;
        position: static;
        transform: translateY(0);
        padding-left: 0 !important;

        .form-container {
          margin: 0 auto;
          text-align: left;
        }
      }
    }
  }
</style>
